=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpMavenClient
  class ContentArtifactApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a maven artifact
    # A ViewSet for MavenArtifact.
    # @param maven_maven_artifact [MavenMavenArtifact] 
    # @param [Hash] opts the optional parameters
    # @return [MavenMavenArtifactResponse]
    def create(maven_maven_artifact, opts = {})
      data, _status_code, _headers = create_with_http_info(maven_maven_artifact, opts)
      data
    end

    # Create a maven artifact
    # A ViewSet for MavenArtifact.
    # @param maven_maven_artifact [MavenMavenArtifact] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(MavenMavenArtifactResponse, Integer, Hash)>] MavenMavenArtifactResponse data, response status code and response headers
    def create_with_http_info(maven_maven_artifact, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentArtifactApi.create ...'
      end
      # verify the required parameter 'maven_maven_artifact' is set
      if @api_client.config.client_side_validation && maven_maven_artifact.nil?
        fail ArgumentError, "Missing the required parameter 'maven_maven_artifact' when calling ContentArtifactApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/maven/artifact/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(maven_maven_artifact) 

      # return_type
      return_type = opts[:return_type] || 'MavenMavenArtifactResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentArtifactApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List maven artifacts
    # A ViewSet for MavenArtifact.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :artifact_id Filter results where artifact_id matches value
    # @option opts [String] :filename Filter results where filename matches value
    # @option opts [String] :group_id Filter results where group_id matches value
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :version Filter results where version matches value
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedmavenMavenArtifactResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List maven artifacts
    # A ViewSet for MavenArtifact.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :artifact_id Filter results where artifact_id matches value
    # @option opts [String] :filename Filter results where filename matches value
    # @option opts [String] :group_id Filter results where group_id matches value
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :version Filter results where version matches value
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedmavenMavenArtifactResponseList, Integer, Hash)>] PaginatedmavenMavenArtifactResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentArtifactApi.list ...'
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/maven/artifact/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'artifact_id'] = opts[:'artifact_id'] if !opts[:'artifact_id'].nil?
      query_params[:'filename'] = opts[:'filename'] if !opts[:'filename'].nil?
      query_params[:'group_id'] = opts[:'group_id'] if !opts[:'group_id'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'repository_version'] = opts[:'repository_version'] if !opts[:'repository_version'].nil?
      query_params[:'repository_version_added'] = opts[:'repository_version_added'] if !opts[:'repository_version_added'].nil?
      query_params[:'repository_version_removed'] = opts[:'repository_version_removed'] if !opts[:'repository_version_removed'].nil?
      query_params[:'version'] = opts[:'version'] if !opts[:'version'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedmavenMavenArtifactResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentArtifactApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a maven artifact
    # A ViewSet for MavenArtifact.
    # @param maven_maven_artifact_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [MavenMavenArtifactResponse]
    def read(maven_maven_artifact_href, opts = {})
      data, _status_code, _headers = read_with_http_info(maven_maven_artifact_href, opts)
      data
    end

    # Inspect a maven artifact
    # A ViewSet for MavenArtifact.
    # @param maven_maven_artifact_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(MavenMavenArtifactResponse, Integer, Hash)>] MavenMavenArtifactResponse data, response status code and response headers
    def read_with_http_info(maven_maven_artifact_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentArtifactApi.read ...'
      end
      # verify the required parameter 'maven_maven_artifact_href' is set
      if @api_client.config.client_side_validation && maven_maven_artifact_href.nil?
        fail ArgumentError, "Missing the required parameter 'maven_maven_artifact_href' when calling ContentArtifactApi.read"
      end
      # resource path
      local_var_path = '{maven_maven_artifact_href}'.sub('{' + 'maven_maven_artifact_href' + '}', CGI.escape(maven_maven_artifact_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'MavenMavenArtifactResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentArtifactApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
